"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing_extensions import Annotated, TypedDict


class YieldType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""The type of yield."""

    YIELD_TYPE_UNSPECIFIED = "YIELD_TYPE_UNSPECIFIED"
    YIELD_TO_CALL = "YIELD_TO_CALL"
    YIELD_TO_MATURITY = "YIELD_TO_MATURITY"
    YIELD_TO_PUT = "YIELD_TO_PUT"
    YIELD_TO_WORST = "YIELD_TO_WORST"


class BondYieldCreateTypedDict(TypedDict):
    r"""A percentage yield"""

    percent: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    yield_type: YieldType
    r"""The type of yield."""


class BondYieldCreate(BaseModel):
    r"""A percentage yield"""

    percent: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    yield_type: Annotated[YieldType, PlainValidator(validate_open_enum(False))]
    r"""The type of yield."""
