"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .foreignnaturalpersonaccountenrollmentmetadatacreate import (
    ForeignNaturalPersonAccountEnrollmentMetadataCreate,
    ForeignNaturalPersonAccountEnrollmentMetadataCreateTypedDict,
)
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class ForeignJointAccountEnrollmentMetadataCreateDividendReinvestmentPlan(
    str, Enum, metaclass=utils.OpenEnumMeta
):
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to DIVIDEND_REINVESTMENT_ENROLL"""

    AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED = (
        "AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED"
    )
    DIVIDEND_REINVESTMENT_ENROLL = "DIVIDEND_REINVESTMENT_ENROLL"
    DIVIDEND_REINVESTMENT_DECLINE = "DIVIDEND_REINVESTMENT_DECLINE"


class ForeignJointAccountEnrollmentMetadataCreateFdicCashSweep(
    str, Enum, metaclass=utils.OpenEnumMeta
):
    r"""Option to auto-enroll in FDIC cash sweep; defaults to FDIC_CASH_SWEEP_ENROLL"""

    AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED = "AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED"
    FDIC_CASH_SWEEP_ENROLL = "FDIC_CASH_SWEEP_ENROLL"
    FDIC_CASH_SWEEP_DECLINE = "FDIC_CASH_SWEEP_DECLINE"


class ForeignJointAccountEnrollmentMetadataCreateTypedDict(TypedDict):
    r"""Enrollment metadata for the FOREIGN_JOINT_WROS enrollment type"""

    foreign_natural_person_account_enrollment_metadata: (
        ForeignNaturalPersonAccountEnrollmentMetadataCreateTypedDict
    )
    r"""Enrollment metadata for Accounts that have a foreign Legal Natural Person owner."""
    dividend_reinvestment_plan: NotRequired[
        ForeignJointAccountEnrollmentMetadataCreateDividendReinvestmentPlan
    ]
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to DIVIDEND_REINVESTMENT_ENROLL"""
    fdic_cash_sweep: NotRequired[
        ForeignJointAccountEnrollmentMetadataCreateFdicCashSweep
    ]
    r"""Option to auto-enroll in FDIC cash sweep; defaults to FDIC_CASH_SWEEP_ENROLL"""


class ForeignJointAccountEnrollmentMetadataCreate(BaseModel):
    r"""Enrollment metadata for the FOREIGN_JOINT_WROS enrollment type"""

    foreign_natural_person_account_enrollment_metadata: (
        ForeignNaturalPersonAccountEnrollmentMetadataCreate
    )
    r"""Enrollment metadata for Accounts that have a foreign Legal Natural Person owner."""

    dividend_reinvestment_plan: Annotated[
        Optional[ForeignJointAccountEnrollmentMetadataCreateDividendReinvestmentPlan],
        PlainValidator(validate_open_enum(False)),
    ] = None
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to DIVIDEND_REINVESTMENT_ENROLL"""

    fdic_cash_sweep: Annotated[
        Optional[ForeignJointAccountEnrollmentMetadataCreateFdicCashSweep],
        PlainValidator(validate_open_enum(False)),
    ] = None
    r"""Option to auto-enroll in FDIC cash sweep; defaults to FDIC_CASH_SWEEP_ENROLL"""
